您的位置:首页 > 其它

CodeForces - 540C Ice Cave(BFS)

2017-09-20 15:38 281 查看

CodeForces - 540C Ice Cave

You play a computer game. Your character stands on some level of a multilevel ice cave. In order to move on forward, you need to descend one level lower and the only way to do this is to fall through the ice.

The level of the cave where you are is a rectangular square grid of n rows and m columns. Each cell consists either from intact or from cracked ice. From each cell you can move to cells that are side-adjacent with yours (due to some limitations of the game
engine you cannot make jumps on the same place, i.e. jump from a cell to itself). If you move to the cell with cracked ice, then your character falls down through it and if you move to the cell with intact ice, then the ice on this cell becomes cracked.

Let's number the rows with integers from 1 to n from top to bottom and the columns with integers from 1 to m from left to right. Let's denote a cell on the intersection of the r-th row and the c-th column as (r, c).

You are staying in the cell (r1, c1) and this cell is cracked because you've just fallen here from a higher level. You need to fall down through the cell (r2, c2) since the exit to the next level is there. Can you do this?

Input

The first line contains two integers, n and m (1 ≤ n, m ≤ 500) — the number of rows and columns in the cave description.

Each of the next n lines describes the initial state of the level of the cave, each line consists of m characters "." (that is, intact ice) and "X" (cracked ice).

The next line contains two integers, r1 and c1 (1 ≤ r1 ≤ n, 1 ≤ c1 ≤ m) — your initial coordinates. It is guaranteed that the description of the cave contains character 'X' in cell (r1, c1), that is, the ice on the starting cell is initially cracked.

The next line contains two integers r2 and c2 (1 ≤ r2 ≤ n, 1 ≤ c2 ≤ m) — the coordinates of the cell through which you need to fall. The final cell may coincide with the starting one.

Output

If you can reach the destination, print 'YES', otherwise print 'NO'.

Example

Input

4 6

X...XX

...XX.

.X..X.

......

1 6

2 2

Output

YES

Input

5 4

.X..

...X

X.X.

....

.XX.

5 3

1 1

Output

NO

Input

4 7

..X.XX.

.XX..X.

X...X..

X......

2 2

1 6

Output

YES

题意:矩阵上的的点有完整的冰块,有破碎的冰块,踩到完整的冰块会使冰块破碎,踩到破碎的冰块会掉到下一层,给两个点,问是否能从起始点到下一层的终点,不能在原地踩冰块,起始点肯定为破碎的冰块,起始点与终点可能为同一点

思路:简单的搜索题,用深搜会T掉,用广搜,在遇到终点之前,一直走完整的冰块,把走过的冰块都改为破碎的冰块,判断走到终点时终点是否为破碎的冰块
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<vector>
#include<stack>
#include<queue>
#include<map>
using namespace std;
typedef long long ll;
const int INF = 0x3f3f3f3f;
const int MAX = 501;
char mp[MAX][MAX];
int to[4][2]={{0,1},{1,0},{-1,0},{0,-1}};
int sx,sy,ex,ey;
int n,m;
int flag;
struct node{
int x,y;
node(){}
node(int xx,int yy){x=xx,y=yy;}
};
void BFS(){
queue<node> q;
q.push(node(sx,sy));

while(!q.empty()){
struct node t1;
t1=q.front();
q.pop();

for(int i=0;i<=3;i++){
int tx=t1.x+to[i][0];
int ty=t1.y+to[i][1];
if(tx<0||ty<0||tx>=n||ty>=m||(!(tx==ex&&ty==ey)&&mp[tx][ty]=='X'))
continue;
if(tx==ex&&ty==ey&&mp[tx][ty]=='X'){
flag=1;
return;
}
q.push(node(tx,ty));
mp[tx][ty]='X';
}
}
}
int main(void){
scanf("%d%d",&n,&m);
for(int i=0;i<n;i++){
scanf("%s",mp[i]);
}
scanf("%d%d%d%d",&sx,&sy,&ex,&ey);
sx--,sy--,ex--,ey--;
BFS();
if(flag) printf("YES\n");
else printf("NO\n");
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息